package edu.whs.spin2018.baoapp.presenter;

import edu.whs.spin2018.baoapp.model.Benutzer;
import edu.whs.spin2018.baoapp.model.remote.mehrspieler.MehrspielerRemoteDataSource;
import edu.whs.spin2018.baoapp.views.menues.MehrspielerContract;

public class MehrspielerPresenter implements MehrspielerContract.Presenter {

    private MehrspielerContract.View mehrspielerview;
    private MehrspielerRemoteDataSource interactor;

    public MehrspielerPresenter(MehrspielerContract.View mehrspielerview) {
        this.mehrspielerview = mehrspielerview;
    }

    public void starteSchnellspielSuche() {
        interactor.trittWarteschlangeBei();
        mehrspielerview.zeigeGegnerSuche();
    }

    public void beendeSchnellspielSuche() {
        interactor.verlasseWarteschlange();
        mehrspielerview.beendeSchnellspielDialog();
    }

    @Override
    public void stop() {
        this.interactor.entferneRegistrierteListener();
    }

    @Override
    public void setzeServiceInteractor(MehrspielerRemoteDataSource interactor) {
        this.interactor = interactor;
        interactor.setzeListener(this);
    }

    @Override
    public void onGegnerGefunden(Benutzer gegner, String raum) {
        //mehrspielerview.zeigeGegnerGefunden();
        mehrspielerview.starteSpiel(gegner, raum);
    }
}

